//=============================================================================
// Copyright  Micromega Corporation 2005-2008. All rights reserved.
//
// @file	fpu_print.c
// @target	Microchip dsPIC C compiler
//
// uM-FPU V3 print routines.
//
// @author	Cam Thompson, Micromega Corporation
// @version
//	August 26, 2008
//	- modified for Microchip dsPIC C compiler
//	July 2, 2008
//	- original version
//=============================================================================

#include <stdio.h>
#include "fpu.h"

//------------------- print_version -------------------------------------------

void print_version(void) {

	fpu_write(VERSION);
	print_fpuString(READSTR);
}

//------------------- print_float ---------------------------------------------

void print_float(char format) {

	fpu_write2(FTOA, format);
	print_fpuString(READSTR);
}

//------------------- print_long ----------------------------------------------

void print_long(char format) {

	fpu_write2(LTOA, format);
	print_fpuString(READSTR);
}

//------------------- print_fpuString -----------------------------------------

void print_fpuString(char opcode) {
	char bval;

	if (opcode != (char) READSEL) opcode = READSTR;
	fpu_wait();
	fpu_write(opcode);
	fpu_readDelay();

	while (1) {
		bval = fpu_read();
		if (bval == 0) break;
		putchar(bval);
	}
}

//------------------- print_CRLF ----------------------------------------------

void print_CRLF(void) {

	putchar('\r');
	putchar('\n');
}
